﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace _2011_03_29_2011_03_30_Praktikum
{
    public partial class MainWindow : Window
    {
        System.Windows.Threading.DispatcherTimer timer = new System.Windows.Threading.DispatcherTimer();

        public MainWindow()
        {
            InitializeComponent();

            timer.Interval = TimeSpan.FromMinutes(0.1);
            timer.Tick += checkAlarms;
            timer.IsEnabled = true;
        }

        void checkAlarms(object sender, EventArgs e)
        {
            bool alarm = false;
            DateTime now = DateTime.Now;
            for (int i = 0; i < listBoxAlarms.Items.Count; i++)
            {
                AlarmTime at = (AlarmTime)listBoxAlarms.Items[i];
                if(at.Hour == now.Hour && at.Minute == now.Minute)
                {
                    alarm = true;
                    break;
                }
            }
            if (alarm)
            {
                theGrid.Background = Brushes.Red;
                System.Media.SystemSounds.Beep.Play();
            }
            else
            {
                theGrid.Background = Brushes.White;
            }
        }

        private void buttonAdd_Click(object sender, RoutedEventArgs e)
        {
            AlarmTime at = new AlarmTime();
            at.Title = textBoxTitle.Text;
            // Noch zu prüfen: Stehen da Zahlen von 0 bis 23 drin?
            at.Hour = int.Parse(textBoxHours.Text);
            // Noch zu prüfen: Stehen da Zahlen von 0 bis 59 drin?
            at.Minute = int.Parse(textBoxMinutes.Text);
            listBoxAlarms.Items.Add(at);
        }

        private void buttonRemove_Click(object sender, RoutedEventArgs e)
        {
            int i = listBoxAlarms.SelectedIndex;
            if (i >= 0)
            {
                listBoxAlarms.Items.RemoveAt(i);
            }
        }

        private void listBoxAlarms_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            AlarmTime at = (AlarmTime)listBoxAlarms.SelectedItem;
            if (at != null)
            {
                buttonRemove.IsEnabled = true;
                textBoxHours.Text = at.Hour.ToString();
                textBoxMinutes.Text = at.Minute.ToString();
                textBoxTitle.Text = at.Title;
            }
            else
            {
                buttonRemove.IsEnabled = false;
            }
        }

        private void textBoxHours_TextChanged(object sender, TextChangedEventArgs e)
        {
            AlarmTime at = (AlarmTime)listBoxAlarms.SelectedItem;
            if (at != null)
            {
                // Noch zu prüfen: Stehen da Zahlen von 0 bis 23 drin?
                at.Hour = int.Parse(textBoxHours.Text);
            }
        }

        private void textBoxMinutes_TextChanged(object sender, TextChangedEventArgs e)
        {
            AlarmTime at = (AlarmTime)listBoxAlarms.SelectedItem;
            if (at != null)
            {
                // Noch zu prüfen: Stehen da Zahlen von 0 bis 59 drin?
                at.Minute = int.Parse(textBoxMinutes.Text);
            }
        }

        private void textBoxTitle_TextChanged(object sender, TextChangedEventArgs e)
        {
            AlarmTime at = (AlarmTime)listBoxAlarms.SelectedItem;
            if (at != null)
            {
                at.Title = textBoxTitle.Text;
                listBoxAlarms.Items.Refresh(); // um den neuen Titel in die Liste zu holen
            }
        }
    }
}
